import greenfoot.*;
import java.util.List;
import javax.swing.JOptionPane;
import java.awt.Color;

public class Room extends World
{
    public Room()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(300, 300, 1);
        Greenfoot.start();
        addObject(new Fps(),30,15);
        addObject(new Ball(),getWidth()/2,getHeight()/2);
        addObject(new Box(30,getHeight(),Color.WHITE),15,getHeight()/2);
        addObject(new Box(30,getHeight(),Color.BLUE),getWidth()-15,getHeight()/2);
        addObject(new Box(getWidth(),30,Color.GREEN),getWidth()/2,15);
        addObject(new Box(getWidth(),30,Color.YELLOW),getWidth()/2,getHeight()-15);
        //addObject(new MenuSelection("Lock Scenario","","Blocked",Color.BLACK,Color.YELLOW),getWidth()/2,15);
    }
    boolean shadowImagery=false;
    boolean gravity=true;
    String gravityDirection="down";
    boolean sdown=false;
    boolean gdown=false;
    public void act(){
        setPaintOrder(Fps.class,Ball.class,Box.class);
        addRemoveMatter();
        matterProportyControls();
        updateMatterProperties();
    }
    int clickCooldown=5;
    public void addRemoveMatter(){
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if (mouse==null)return;
        if (clickCooldown!=0){clickCooldown--; return;}
        if (mouse.getButton()<3)return;
        clickCooldown=5;
        List all = getObjectsAt(mouse.getX(),mouse.getY(),Actor.class);
        if (! all.isEmpty()){
            for (int i=0; i<all.size(); i++){
                try{
                    Matter matter = (Matter) all.get(i);
                    if (matter!=null){removeObject(matter); break;}
                }catch(ClassCastException e){}
            }
            return;
        }
        addObject(new Ball(),mouse.getX(),mouse.getY());
    }
    public void matterProportyControls(){
        //Shadow Imagery
        if (Greenfoot.isKeyDown("s")&&sdown==false){
            if (shadowImagery==false){shadowImagery=true;}else{shadowImagery=false;}
            sdown=true;
        }else if (! Greenfoot.isKeyDown("s")){sdown=false;}
        //Toggle Gravity
        if (Greenfoot.isKeyDown("g")&&gdown==false){
            if (gravity==true){gravity=false;}else{gravity=true;}
            gdown=true;
        }else if (! Greenfoot.isKeyDown("g")){gdown=false;}
        //Change Gravity Direction
        if (Greenfoot.isKeyDown("up"))gravityDirection="up";
        if (Greenfoot.isKeyDown("down"))gravityDirection="down";
        if (Greenfoot.isKeyDown("left"))gravityDirection="left";
        if (Greenfoot.isKeyDown("right"))gravityDirection="right";
    }
    public void updateMatterProperties(){
        List<Matter> AllMatter = getObjects(Matter.class);
        for (Matter matter : AllMatter){
            matter.shadowImagery(shadowImagery);
            matter.gravity(gravity);
            matter.gravityDirection(gravityDirection);
        }
    }
}
